# Class BluetoothDevice

java.lang.Object
com.codename1.bluetooth.BluetoothDevice

Direct Known Subclasses:
  `BlePeripheral`

public abstract class BluetoothDevice extends Object

Identity of a remote Bluetooth device, shared by the LE and classic stacks. Ports construct concrete subclasses; application code receives them from scans, discovery, and bonded-device listings.

Two devices are equal when their `getAddress()` values are equal, so instances can be used directly as map keys.

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  `protected`
  `BluetoothDevice()`
  Ports construct subclasses; application code receives instances from the scanning and discovery APIs.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `final boolean`
  `equals(Object o)`
  Devices are equal when their `getAddress()` values are equal.
  `abstract String`
  `getAddress()`
  A stable identifier for this device: the MAC address on Android and the desktop ports (`AA:BB:CC:DD:EE:FF`), but the per-app CoreBluetooth identifier UUID string on iOS.
  `BondState`
  `getBondState()`
  The current pairing state of this device; defaults to `BondState.NONE`.
  `abstract String`
  `getName()`
  The advertised or cached device name; may be `null` when the device never advertised one.
  `DeviceType`
  `getType()`
  The transport family of this device; defaults to `DeviceType.UNKNOWN`.
  `final int`
  `hashCode()`
  Returns a hash code value for the object.
  `String`
  `toString()`
  Returns a string representation of the object.

  ### Methods inherited from class Object

  `clone, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### BluetoothDevice

    protected BluetoothDevice()
    Ports construct subclasses; application code receives instances from the scanning and discovery APIs.

- ## Method Details

  - ### getAddress

    public abstract String getAddress()
    A stable identifier for this device: the MAC address on Android and the desktop ports (`AA:BB:CC:DD:EE:FF`), but the per-app CoreBluetooth identifier UUID string on iOS. The value is stable for this app on this device and safe to persist for reconnection on the same install, but it is NOT portable across phones or platforms -- never treat it as the peripheral's real hardware address.

  - ### getName

    public abstract String getName()
    The advertised or cached device name; may be `null` when the device never advertised one.

  - ### getType

    public DeviceType getType()
    The transport family of this device; defaults to `DeviceType.UNKNOWN`.

  - ### getBondState

    public BondState getBondState()
    The current pairing state of this device; defaults to `BondState.NONE`. iOS manages bonds internally and usually reports `BondState.NONE` -- see `BondState`.

  - ### equals

    public final boolean equals(Object o)
    Devices are equal when their `getAddress()` values are equal.
    Overrides:
      `equals` in class `Object`

  - ### hashCode

    public final int hashCode()
    Description copied from class: `Object`
    Returns a hash code value for the object. This method is supported for the benefit of hashtables such as those provided by java.util.Hashtable. The general contract of hashCode is: Whenever it is invoked on the same object more than once during an execution of a Java application, the hashCode method must consistently return the same integer, provided no information used in equals comparisons on the object is modified. This integer need not remain consistent from one execution of an application to another execution of the same application. If two objects are equal according to the equals(Object) method, then calling the hashCode method on each of the two objects must produce the same integer result. It is not required that if two objects are unequal according to the equals(java.lang.Object) method, then calling the hashCode method on each of the two objects must produce distinct integer results. However, the programmer should be aware that producing distinct integer results for unequal objects may improve the performance of hashtables. As much as is reasonably practical, the hashCode method defined by class Object does return distinct integers for distinct objects. (This is typically implemented by converting the internal address of the object into an integer, but this implementation technique is not required by the JavaTM programming language.)
    Overrides:
      `hashCode` in class `Object`

  - ### toString

    public String toString()
    Description copied from class: `Object`
    Returns a string representation of the object. In general, the toString method returns a string that "textually represents" this object. The result should be a concise but informative representation that is easy for a person to read. It is recommended that all subclasses override this method. The toString method for class Object returns a string consisting of the name of the class of which the object is an instance, the at-sign character `@', and the unsigned hexadecimal representation of the hash code of the object. In other words, this method returns a string equal to the value of: getClass().getName() + '@' + Integer.toHexString(hashCode())
    Overrides:
      `toString` in class `Object`